# STEAMDB V0.0.1  
### dependencies: latest version of ruby (2.5.0), active\_record gem, sqlite3 gem  


## Introduction  
### Wellington Gabriel Vicente de Souza - GRR20163081 - CI320

Hi! This is a project made for the second evaluation of the Tópicos em Programação de Computadores (CI320) course at Universidade Federal do Paraná in Brazil. The objective of this project was purely to solidify our knowledge in the Ruby language.   

This project simulates a simplified working database management system similar to sqlite3. It was implemented in the Ruby language and it uses the Active Record gem to establish a connection with sqlite3.  

## How to use  
### Creating the database  
To create the tables defined in the schema.rb file, run: 
$ ruby schema.rb  

The steamdb.sqlite3 file on this repository already contains a few example rows to simplify the testing of the different functionalities. To reset the entire database, simply delete the steamdb.sqlite3 file and run the schema.rb file again.  

The models for each object type are defined in the models.rb file. This database system implements 1 to 1, 1 to n and n to n relationships.  

### Seeding the database
This repository includes a seed file for the database. Just execute the seed_db.sh file to seed the database:  
$ ./seed_db.sh

### Running SteamDB
To run SteamDB, just enter the following command on your terminal:  
$ ruby steamdb.rb

### Instructions
This program contains five basic commands:
 - insere (add a new element)
 - exclui (remove one or more elements)
 - altera (update one or more elements)
 - lista (list all the elements of a table)
 - sair (exit)

### Command syntax  
< op > < table > < { attribute=value } >  

possible < op > values are insere, exclui, altera and lista  
< table > indicates the name of the table you will be using for the operation  
{ ... } indicates the possibility of more than one argument  
attribute=value has different meanings, acting both as a WHERE select and as an attribution  

To clarify, here are some examples:  

Creating a developer named Jose that lives in Brasil:
+ insere developers name="jose" country="brasil"  

Listing all the developers
+ lista developers

Changing the name and country values of the row(s) with a "Jose" value on the name column
+ altera developers name="jose" name="joão" country="usa"

Observation: in the "altera" operation, the first (and only the first) attribute=value pair is used to select one or more rows with the defined value

Deleting a row
+ exclui developers name="joão" country="usa"

Deleting all rows of a table
+ exclui developers

## Relationships
1 to 1 = (Game Price), a game can only have one price list
1 to n = (Developer Game), a developer can have one or more games
n to n = (Category Game), a game can have many categories and categories have many games related to them
