require 'active_record'

ActiveRecord::Base.establish_connection :adapter => "sqlite3",
                                        :database => "steamdb.sqlite3" 

class Game < ActiveRecord::Base; 
	has_one :price, dependent: :destroy
	belongs_to :developer
	has_many :category_games
	has_many :categories, through: :category_games, dependent: :destroy
end

class Developer < ActiveRecord::Base; 
	has_many :games, dependent: :destroy
end

class Price < ActiveRecord::Base;
	belongs_to :game
end

class Category < ActiveRecord::Base;
	has_many :category_games
	has_many :games, through: :category_games, dependent: :destroy
end

class CategoryGame < ActiveRecord::Base;
	belongs_to :category 
	belongs_to :game
end