require './models.rb'

def is_a_string (string)
  string.start_with?('"') && string.end_with?('"') ? true : false
end

def is_a_integer (integer)
  integer =~ /\A\d+\z/ ? true : false
end

def parse_input (string)
  i = 0
  args = []
  arg = ''
  begin_quote = false
  string.each_char do |c|
    if c == '"'
      begin_quote = !begin_quote
    end

    if c != ' ' || begin_quote == true
      arg = arg + c
    else
      args[i] = arg
      i = i + 1
      arg = ''
    end
  end

  if !begin_quote
    args[i] = arg
  else
    puts "Erro de Síntaxe: Aspas não encontradas."
    args = []
  end

  return args
end

def insere(tabela, args)
  error = false
  case tabela 
  when "developers"
    dev = Developer.new ()
    args.each do |x|
      x = x.split("=")
      case x[0] 
      when "name"
        if is_a_string(x[1])
          dev.name = x[1].tr('"','');
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      when "country"
        if is_a_string(x[1])
          dev.country = x[1].tr('"','')
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      else
        puts "Atributo #{x[0]} não encontrado."
        error = true
      end
      if error 
        break
      end 
      next
    end 
    if !error
      dev.save
      puts "Linha inserida na tabela #{tabela}."
    end
  when "games"
    game = Game.new ()
    args.each do |x|
      x = x.split("=")
      case x[0] 
      when "name"
        if is_a_string(x[1])
          game.name = x[1].tr('"','')
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      when "description"
        if is_a_string(x[1])
          game.description = x[1].tr('"','')
        else
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end         
      when "is_released"
        if x[1] === "true" || x[1] === "false"
          game.is_released = x[1] === "true" ? true : false
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end   
      when "developer_id"
        if is_a_integer(x[1]) 
          game.developer_id = x[1]
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      else
        puts "Atributo #{x[0]} não encontrado."
        error = true
      end
      if error 
        break
      end 
      next
    end 
    if (!error)
      game.save
      puts "Linha inserida na tabela #{tabela}."
    end
  when "prices"
    price = Price.new ()
    args.each do |x|
      x = x.split("=")
      case x[0]
      when "price_us"
        if is_a_integer(x[1]) 
          price.price_us = x[1]
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      when "price_br"
        if is_a_integer(x[1]) 
          price.price_br = x[1]
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      when "price_ru"
        if is_a_integer(x[1]) 
          price.price_ru = x[1]
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      when "game_id"
        if is_a_integer(x[1]) 
          price.game_id = x[1]
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      else 
        puts "Atributo #{x[0]} não encontrado."
        error = true
      end
      if error
        break
      end
      next
    end
    if (!error)
      price.save
      puts "Linha inserida na tabela #{tabela}."
    end
  when "categories"
    category = Category.new ()
    args.each do |x|
      x = x.split("=")
      case x[0] 
      when "name"
        if is_a_string(x[1])
          category.name = x[1].tr('"','')
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      when "description"
        if is_a_string(x[1])
          category.description = x[1].tr('"','')
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      else
        puts "Atributo #{x[0]} não encontrado."
        error = true
      end
      if error 
        break
      end 
      next
    end 
    if (!error)
      category.save
      puts "Linha inserida na tabela #{tabela}."
    end
  when "category_games"
    category_game = CategoryGame.new ()
    args.each do |x|
      x = x.split("=")
      case x[0] 
      when "category_id"
        if is_a_integer(x[1])
          category_game.category_id = x[1];
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      when "game_id"
        if is_a_integer(x[1])
          category_game.game_id = x[1]
        else
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
          error = true
        end
      else
        puts "Atributo #{x[0]} não encontrado."
        error = true
      end
      if error 
        break
      end 
      next
    end 
    if (!error)
      category_game.save
      puts "Linha inserida na tabela #{tabela}."
    end
  else
    puts "Tabela #{tabela} não encontrada."
  end
end

def select_rows(tabela, args)
  selected = []
  error = false
  case tabela
  when "developers"
    selected = Developer.all
    args.each do |x|
      x = x.split("=")
      case x[0]
      when "id"
        if (is_a_integer(x[1]))
          selected = selected.select {|delete| delete.id == x[1].to_i}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      when "name"
        if is_a_string(x[1])
          selected = selected.select {|delete| delete.name == x[1].tr('"','')}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      when "country"
        if is_a_string(x[1])
          selected = selected.select {|delete| delete.country == x[1].tr('"','')}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      else 
        puts "Atributo #{x[0]} não encontrado."
        error = true
      end
      if error 
        break
      end 
      next
    end
  when "games"
    selected = Game.all
    args.each do |x|
      x = x.split("=")
      case x[0]
      when "id"
        if (is_a_integer(x[1]))
          selected = selected.select {|delete| delete.id == x[1].to_i}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      when "name"
        if is_a_string(x[1])
          selected = selected.select {|delete| delete.name == x[1].tr('"','')}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      when "description"
        if is_a_string(x[1])
          selected = selected.select {|delete| delete.country == x[1].tr('"','')}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      when "is_released"
        if x[1] === "true" || x[1] === "false"
          selected = selected.select {|delete| (delete.is_released == (x[1] === "true" ? true : false))}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      when "developer_id"
        if is_a_integer(x[1])
          selected = selected.select {|delete| delete.developer_id == x[1].to_i}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      else 
        puts "Atributo #{x[0]} não encontrado."
        error = true
      end
      if error 
        break
      end 
      next
    end
  when "prices"
    selected = Price.all
    args.each do |x|
      x = x.split("=")
      case x[0]
      when "id"
        if (is_a_integer(x[1]))
          selected = selected.select {|delete| delete.id == x[1].to_i}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end  
      when "price_us"
      	if is_a_integer(x[1])
      	  selected = selected.select {|delete| delete.price_us == x[1].to_i}
      	else 
      	  puts "Erro de Síntaxe: valor inválido para #{x[0]}"
      	  error = true
      	end
      when "price_br"
      	if is_a_integer(x[1])
      	  selected = selected.select {|delete| delete.price_br == x[1].to_i}
      	else 
      	  puts "Erro de Síntaxe: valor inválido para #{x[0]}"
      	  error = true
      	end
      when "price_ru"
      	if is_a_integer(x[1])
      	  selected = selected.select {|delete| delete.price_ru == x[1].to_i}
      	else 
      	  puts "Erro de Síntaxe: valor inválido para #{x[0]}"
      	  error = true
      	end
      when "game_id"
      	if is_a_integer(x[1])
      	  selected = selected.select {|delete| delete.game_id == x[1].to_i}
      	else 
      	  puts "Erro de Síntaxe: valor inválido para #{x[0]}"
      	  error = true
      	end
      else 
      	puts "Atributo #{x[0]} não encontrado."
      	error = true;
      end
      if error 
        break
      end 
      next
    end
  when "categories"
    selected = Category.all
    args.each do |x|
      x = x.split("=")
      case x[0]
      when "id"
        if (is_a_integer(x[1]))
          selected = selected.select {|delete| delete.id == x[1].to_i}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      when "name"
        if is_a_string(x[1])
          selected = selected.select {|delete| delete.name == x[1].tr('"','')}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      when "description"
        if is_a_string(x[1])
          selected = selected.select {|delete| delete.name == x[1].tr('"','')}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      else 
        puts "Atributo #{x[0]} não encontrado."
        error = true;
      end
      if error 
        break
      end 
      next
    end
  when "category_games"
    selected = CategoryGame.all
    args.each do |x|
      x = x.split("=")
      case x[0]
      when "category_id"
        if (is_a_integer(x[1]))
          selected = selected.select {|delete| delete.category_id == x[1].to_i}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      when "game_id"
        if (is_a_integer(x[1]))
          selected = selected.select {|delete| delete.category_id == x[1].to_i}
        else 
          puts "Erro de Síntaxe: Valor inválido para #{x[0]}"
          error = true
        end
      else 
        puts "Atributo #{x[0]} não encontrado."
        error = true;
      end
      if error 
        break
      end 
      next
    end
  else
    puts "Tabela #{tabela} não encontrada."
  end
  return selected
end

def exclui(tabela, args)
  selected = select_rows(tabela,args)
  if selected.length > 0
    selected.each do |d|
      d.destroy
    end
  end
  puts "#{selected.length} linha(s) deletada(s) da tabela #{tabela}!"
end

def altera(tabela, args)
  error = false
  case tabela
  when "developers"
    selected = select_rows(tabela, args[0..0])
    args[1..args.length-1].each do |x|
      x = x.split("=")
      selected.each do |dev|
        case x[0] 
        when "name"
          if is_a_string(x[1])
            dev.name = x[1].tr('"','');
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        when "country"
          if is_a_string(x[1])
            dev.country = x[1].tr('"','')
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        else
          puts "Atributo #{x[0]} não encontrado."
          error = true
        end
        if error 
          break
        else
          dev.save
        end
      end 
      next
    end
    if !error
      puts "#{selected.length} linha(s) atualizada(s) na tabela #{tabela}!"
    end
  when "games"
    selected = select_rows(tabela, args[0..0])
    args[1..args.length-1].each do |x|
      x = x.split("=")
      selected.each do |game|
        case x[0] 
        when "name"
          if is_a_string(x[1])
            game.name = x[1].tr('"','')
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        when "description"
          if is_a_string(x[1])
            game.description = x[1].tr('"','')
          else
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end         
        when "is_released"
          if x[1] === "true" || x[1] === "false"
            game.is_released = x[1] === "true" ? true : false
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end   
        when "developer_id"
          if is_a_integer(x[1]) 
            game.developer_id = x[1]
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        else
          puts "Atributo #{x[0]} não encontrado."
          error = true
        end
        if error 
          break
        else
          game.save
        end
      end 
      next
    end
    if !error
      puts "#{selected.length} linha(s) atualizada(s) na tabela #{tabela}!"
    end
  when "prices"
    selected = select_rows(tabela, args[0..0])
    args[1..args.length-1].each do |x|
      x = x.split("=")
      selected.each do |price|
        case x[0]
        when "price_us"
          if is_a_integer(x[1]) 
            price.price_us = x[1]
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        when "price_br"
          if is_a_integer(x[1]) 
            price.price_br = x[1]
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        when "price_ru"
          if is_a_integer(x[1]) 
            price.price_ru = x[1]
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        when "game_id"
          if is_a_integer(x[1]) 
            price.game_id = x[1]
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        else 
          puts "Atributo #{x[0]} não encontrado."
          error = true
        end
        if error 
          break
        else
          price.save
        end
      end 
      next
    end
    if !error
      puts "#{selected.length} linha(s) atualizada(s) na tabela #{tabela}!"
    end
  when "categories"
    selected = select_rows(tabela, args[0..0])
    args[1..args.length-1].each do |x|
      x = x.split("=")
      selected.each do |category|
        case x[0] 
        when "name"
          if is_a_string(x[1])
            category.name = x[1].tr('"','')
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        when "description"
          if is_a_string(x[1])
            category.description = x[1].tr('"','')
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        else
          puts "Atributo #{x[0]} não encontrado."
          error = true
        end
        if error 
          break
        else
          category.save
        end
      end 
      next
    end
    if !error
      puts "#{selected.length} linha(s) atualizada(s) na tabela #{tabela}!"
    end    
  when "category_games"
    selected = select_rows(tabela, args[0..0])
    args[1..args.length-1].each do |x|
      x = x.split("=")
      selected.each do |game|
        case x[0] 
        when "category_id"
          if is_a_integer(x[1])
            category_game.category_id = x[1];
          else 
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        when "game_id"
          if is_a_integer(x[1])
            category_game.game_id = x[1]
          else
            puts "Erro de Síntaxe: Valor inválido para #{x[0]}!"
            error = true
          end
        else
          puts "Atributo #{x[0]} não encontrado."
          error = true
        end
        if error 
          break
        else
          category_game.save
        end
      end 
      next
    end
    if !error
      puts "#{selected.length} linha(s) atualizada(s) na tabela #{tabela}!"
    end    
  else
    puts "Tabela #{tabela} não encontrada."
  end
end

def lista(tabela)
  error = false
  case tabela
  when "developers"
    lista = Developer.all
    puts "id|name|country"
    lista.each do |l| 
      puts "#{l.id}|#{l.name}|#{l.country}"
    end
  when "games"
    lista = Game.all
    puts "id|name|description|is_released|developer_id"
    lista.each do |l| 
      puts "#{l.id}|#{l.name}|#{l.description}|#{l.is_released}|#{l.developer_id}"
    end   
  when "prices"
    lista = Price.all
    puts "id|price_us|price_br|price_ru|game_id"
    lista.each do |l| 
      puts "#{l.id}|#{l.price_us}|#{l.price_br}|#{l.price_ru}|#{l.game_id}"
    end
  when "categories"
    lista = Category.all
    puts "id|name|description"
    lista.each do |l| 
      puts "#{l.id}|#{l.name}|#{l.description}"
    end
  when "category_games"
    lista = CategoryGame.all
    puts "category_id|game_id"
    lista.each do |l| 
      puts "#{l.category_id}|#{l.game_id}"
    end
  else
    puts "Tabela #{tabela} não encontrada."
    error = true
  end
  if !error 
    puts "Tabela #{tabela} listada com sucesso!"
  end
end

puts "Olá! Seja bem vindo ao SteamDB!"

while true do
  args = parse_input(gets.tr("\n",""))
  if args.length > 0
    case args[0]
    when "insere"
      if args.length > 2 
        insere(args[1],args[2..args.length-1])
      else
        puts "Erro: não há parâmetros o suficiente para inserir um novo elemento."
      end
    when "exclui"
      if args.length > 1
        exclui(args[1],args[2..args.length-1])
      else
        puts "Erro: não há parâmetros o suficiente para excluir um elemento."
      end
    when "altera"
      if args.length > 3
        altera(args[1],args[2..args.length-1])
      else 
        puts "Erro: não há parâmetros o suficiente para atualizar a tabela."
      end
    when "lista"
      if args.length == 2
        lista(args[1])
      else 
        puts "Erro: número inválido de parâmetros."
      end
    when "sair"
      puts "Tchau! :)"
      exit()
    else 
      puts "Comando não encontrado."
    end
  end
end
